"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.classname = classname;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _createForOfIteratorHelper2 = _interopRequireDefault(require("@babel/runtime/helpers/createForOfIteratorHelper"));
var _state = require("@codemirror/state");
var _view = require("@codemirror/view");
function stripeDeco(view, opts) {
  var builder = new _state.RangeSetBuilder();
  var _iterator = (0, _createForOfIteratorHelper2["default"])(view.visibleRanges),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var _step$value = _step.value,
        from = _step$value.from,
        to = _step$value.to;
      for (var pos = from; pos <= to;) {
        var line = view.state.doc.lineAt(pos);
        if (opts.add && typeof opts.add === 'function') {
          var cls = opts.add(line.number);
          if (cls && typeof cls === 'string') {
            var attributes = {
              "class": cls
            };
            builder.add(line.from, line.from, _view.Decoration.line({
              attributes: attributes
            }));
          }
        }
        pos = line.to + 1;
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return builder.finish();
}
function classname() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return _view.ViewPlugin.fromClass(/*#__PURE__*/function () {
    function _class(view) {
      (0, _classCallCheck2["default"])(this, _class);
      (0, _defineProperty2["default"])(this, "decorations", void 0);
      this.decorations = stripeDeco(view, options);
    }
    return (0, _createClass2["default"])(_class, [{
      key: "update",
      value: function update(_update) {
        if (_update.docChanged || _update.viewportChanged) {
          this.decorations = stripeDeco(_update.view, options);
        }
      }
    }]);
  }(), {
    decorations: function decorations(v) {
      return v.decorations;
    }
  });
}