import { RangeSetBuilder } from '@codemirror/state';
import { Decoration, ViewPlugin } from '@codemirror/view';
function stripeDeco(view, opts) {
  var builder = new RangeSetBuilder();
  for (var {
    from,
    to
  } of view.visibleRanges) {
    for (var pos = from; pos <= to;) {
      var line = view.state.doc.lineAt(pos);
      if (opts.add && typeof opts.add === 'function') {
        var cls = opts.add(line.number);
        if (cls && typeof cls === 'string') {
          var attributes = {
            class: cls
          };
          builder.add(line.from, line.from, Decoration.line({
            attributes
          }));
        }
      }
      pos = line.to + 1;
    }
  }
  return builder.finish();
}
export function classname(options) {
  if (options === void 0) {
    options = {};
  }
  return ViewPlugin.fromClass(class {
    constructor(view) {
      this.decorations = void 0;
      this.decorations = stripeDeco(view, options);
    }
    update(update) {
      if (update.docChanged || update.viewportChanged) {
        this.decorations = stripeDeco(update.view, options);
      }
    }
  }, {
    decorations: v => v.decorations
  });
}